#!/usr/bin/env bash

if [[ $# -ne 1 ]]; then
    echo "Usage: ./tag_and_release.sh geosphere|geosphere-test|gcp"
    exit 1
fi

deploy_id="$1"
if [[ $deploy_id == "geosphere" ]]; then
    tag_prefix=""
elif [[ $deploy_id == "geosphere-test" ]]; then
    tag_prefix="test-"
elif [[ $deploy_id == "gcp" ]]; then
    tag_prefix="gcp-"
else
    echo "Unrecognized deploy target: $deploy_id. Should be one of 'geosphere, geosphere-test, gcp'"
    exit 2
fi

current_branch=$(git rev-parse --abbrev-ref HEAD)
if [[ $current_branch != "master" ]]; then
    echo "Can only tag from the 'master' branch"
    exit 1
fi

D=$(date -u +%Y%m%d_%H%M)
tag_id="${tag_prefix}r${D}"
echo "New tag: ${tag_id}"
git tag -a "${tag_id}" -m "Revision ${D}"
read -p "Press enter to push the tag"
git push --follow-tags